#include	"h_MMC2.h"

static	TMMC2	MMC2;

void	MMC2_Init (void (*Sync)(void))
{
	u8 x;
	for (x = 0; x < 2; x++)
	{
		MMC2.LatchState[x] = 0xFE;
		MMC2.Latch0[x] = 0;
		MMC2.Latch1[x] = 0;
	}
	for (x = 0xA; x < 0x10; x++)
		MP->SetWriteHandler(x,MMC2_Write);
	MMC2.Sync = Sync;
	MMC2.Sync();
}

int	MMC2_SaveMI (Ar128 MI)
{
	u8 x = 0;
	MI[x++] = MMC2.LatchState[0];
	MI[x++] = MMC2.LatchState[1];
	MI[x++] = MMC2.Latch0[0];
	MI[x++] = MMC2.Latch0[1];
	MI[x++] = MMC2.Latch1[0];
	MI[x++] = MMC2.Latch1[1];
	return x;
}

int	MMC2_LoadMI (const Ar128 MI)
{
	u8 x = 0;
	MMC2.LatchState[0]	= MI[x++];
	MMC2.LatchState[1]	= MI[x++];
	MMC2.Latch0[0]		= MI[x++];
	MMC2.Latch0[1]		= MI[x++];
	MMC2.Latch1[0]		= MI[x++];
	MMC2.Latch1[1]		= MI[x++];
	return x;
}

void	MMC2_SyncPRG (int Mask)
{
	MP->SetPRG_ROM8(0x8,MMC2.PRG & Mask);
	MP->SetPRG_ROM8(0xA,~2 & Mask);
	MP->SetPRG_ROM8(0xC,~1 & Mask);
	MP->SetPRG_ROM8(0xE,Mask);
}

void	MMC2_SyncCHR (void)
{
	if (MMC2.LatchState[0] == 0xFD)
		MP->SetCHR_ROM4(0,MMC2.Latch0[0]);
	else if (MMC2.LatchState[0] == 0xFE)
		MP->SetCHR_ROM4(0,MMC2.Latch0[1]);
	else	MP->DbgOut("WARNING: MMC2 latch 0 undefined!");

	if (MMC2.LatchState[1] == 0xFD)
		MP->SetCHR_ROM4(4,MMC2.Latch1[0]);
	else if (MMC2.LatchState[1] == 0xFE)
		MP->SetCHR_ROM4(4,MMC2.Latch1[1]);
	else	MP->DbgOut("WARNING: MMC2 latch 1 undefined!");
}

void	MMC2_SyncMirror (void)
{
	if (MMC2.Mirror & 1)
		MP->Mirror_H();
	else	MP->Mirror_V();
}

int	MMC2_TileHandler (int Bank, int TileNum, int Index)
{
	if ((TileNum == 0xFD) || (TileNum == 0xFE))
	{
		MMC2.LatchState[Bank ? 1 : 0] = TileNum;
		MMC2_SyncCHR();
		return 1;
	}
	return 0;
}

void	MMC2_Write (int Bank, int Where, int What)
{
	switch (Bank)
	{
	case 0xA:	MMC2.PRG = What & 0xF;		break;
	case 0xB:	MMC2.Latch0[0] = What & 0x1F;	break;
	case 0xC:	MMC2.Latch0[1] = What & 0x1F;	break;
	case 0xD:	MMC2.Latch1[0] = What & 0x1F;	break;
	case 0xE:	MMC2.Latch1[1] = What & 0x1F;	break;
	case 0xF:	MMC2.Mirror = What;		break;
	}
	MMC2.Sync();
}