#include	"..\..\DLL\d_UNIF.h"

static	struct
{
	int Game, Bank;
}	Regs;

static	void	SaveMI (Ar128 MI)
{
	u8 x = 0;
	MI[x++] = Regs.Game;
	MI[x++] = Regs.Bank;
}

static	void	LoadMI (const Ar128 MI)
{
	u8 x = 0;
	Regs.Game = MI[x++];
	Regs.Bank = MI[x++];
}

static	void	SyncPRG (void)
{
	MP->SetPRG_ROM8(0x6,((Regs.Game & 0xF) << 4) | 0xF);
	if (Regs.Game & 0x10)
	{
		MP->SetPRG_ROM16(0x8,((Regs.Game & 0xF) << 3) | Regs.Bank);
		MP->SetPRG_ROM16(0xC,((Regs.Game & 0xF) << 3) | 0x7);
	}
	else	MP->SetPRG_ROM32(0x8,0x40); /* the EPROM at the end */
	if (Regs.Game & 0x20)
		MP->Mirror_H();
	else	MP->Mirror_V();
}

static	void	WriteMenu (int Bank, int Where, int What)
{
	if (Regs.Game & 0x10)	return;
	Regs.Game = What & 0x3F;
	SyncPRG();
}

static	void	WriteBank (int Bank, int Where, int What)
{
	Regs.Bank = What & 0x7;
	SyncPRG();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	u8 x;
	MP = _MP;
	for (x = 0x6; x < 0x8; x++)
		MP->SetWriteHandler(x,WriteMenu);
	for (x = 0x8; x < 0x10; x++)
		MP->SetWriteHandler(x,WriteBank);
	MP->SetCHR_RAM8(0,0);

	Regs.Game = 0;
	Regs.Bank = 0;

	SyncPRG();
}

const	TMapperInfo	MapperInfo_BMC_Supervision16in1 =
{
	"BMC-Supervision16in1",
	-1,
	MS_Full,
	16384,
	InitMapper,
	NULL,
	NULL,
	NULL,
	SaveMI,
	LoadMI,
	NULL,
	NULL
};