#include	"..\..\DLL\d_UNIF.h"
#include	"..\..\Hardware\h_MMC3.h"

static	void	Sync_TFROM (void)
{
	MMC3_SyncPRG(0x3F,0);
	MMC3_SyncCHR_ROM(0x3F,0);
	UNIF_SetMirroring(MMC3_SyncMirror);
}
static	void	Sync_TGROM (void)
{
	MMC3_SyncPRG(0x3F,0);
	MMC3_SyncCHR_RAM();
	MMC3_SyncMirror();
}
static	void	Sync_TKROM (void)
{
	MMC3_SyncPRG(0x3F,0);
	MMC3_SyncCHR_ROM(0xFF,0);
	MMC3_SyncMirror();
}
static	void	Sync_TLROM (void)
{
	MMC3_SyncPRG(0x3F,0);
	MMC3_SyncCHR_ROM(0xFF,0);
	MMC3_SyncMirror();
}
static	void	Sync_TR1ROM (void)
{
	MMC3_SyncPRG(0x3F,0);
	MMC3_SyncCHR_ROM(0x3F,0);
	MP->Mirror_4();
}
static	void	Sync_TSROM (void)
{
	MMC3_SyncPRG(0x3F,0);
	MMC3_SyncCHR_ROM(0xFF,0);
	MMC3_SyncMirror();
}

static	void	InitMapper_TFROM (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;
	MMC3_Init(Sync_TFROM);
}
static	void	InitMapper_TGROM (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;
	MMC3_Init(Sync_TGROM);
}

static	void	InitMapper_TKROM (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;
	MMC3_Init(Sync_TKROM);
}

static	void	InitMapper_TLROM (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;
	MMC3_Init(Sync_TLROM);
}

static	void	InitMapper_TR1ROM (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;
	MMC3_Init(Sync_TR1ROM);
}

static	void	InitMapper_TSROM (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;
	MMC3_Init(Sync_TSROM);
}

const	TMapperInfo	MapperInfo_NES_TFROM =
{
	"NES-TFROM",
	-1,
	MS_Nearly,
	8192,
	InitMapper_TFROM,
	NULL,
	MMC3_HBlank,
	NULL,
	MMC3_SaveMI,
	MMC3_LoadMI,
	NULL,
	NULL
};
const	TMapperInfo	MapperInfo_NES_TGROM =
{
	"NES-TGROM",
	-1,
	MS_Nearly,
	8192,
	InitMapper_TGROM,
	NULL,
	MMC3_HBlank,
	NULL,
	MMC3_SaveMI,
	MMC3_LoadMI,
	NULL,
	NULL
};
const	TMapperInfo	MapperInfo_NES_TKROM =
{
	"NES-TKROM",
	-1,
	MS_Nearly,
	8192,
	InitMapper_TKROM,
	NULL,
	MMC3_HBlank,
	NULL,
	MMC3_SaveMI,
	MMC3_LoadMI,
	NULL,
	NULL
};
const	TMapperInfo	MapperInfo_NES_TLROM =
{
	"NES-TLROM",
	-1,
	MS_Nearly,
	8192,
	InitMapper_TLROM,
	NULL,
	MMC3_HBlank,
	NULL,
	MMC3_SaveMI,
	MMC3_LoadMI,
	NULL,
	NULL
};
const	TMapperInfo	MapperInfo_NES_TR1ROM =
{
	"NES-TR1ROM",
	-1,
	MS_Nearly,
	8192,
	InitMapper_TR1ROM,
	NULL,
	MMC3_HBlank,
	NULL,
	MMC3_SaveMI,
	MMC3_LoadMI,
	NULL,
	NULL
};
const	TMapperInfo	MapperInfo_NES_TSROM =
{
	"NES-TSROM",
	-1,
	MS_Nearly,
	8192,
	InitMapper_TSROM,
	NULL,
	MMC3_HBlank,
	NULL,
	MMC3_SaveMI,
	MMC3_LoadMI,
	NULL,
	NULL
};