#include	"..\DLL\d_iNES.h"

static	struct
{
	PWriteFunc PRG_Write_4;
	u8 IRQenabled;
	u16 IRQcounter;
}	Mapper;

static	void	HBlank (int Scanline, int Byte2001)
{
	if (Mapper.IRQenabled)
	{
		Mapper.IRQcounter += 341;		/* (113 + 2/3) * 3 */
		if (Mapper.IRQcounter >= 12288)	/* 4096 * 3 */
		{
			Mapper.IRQcounter = 0;
			MP->IRQ();
		}
	}
}

static	void	PRG_Write_456789ABCDEF (int Bank, int Where, int What)
{
	u16 Loc = (Bank << 12) | Where;
	if (Bank == 4)
		Mapper.PRG_Write_4(Bank,Where,What);
	if ((Loc & 0x1FF) == 0x4022)
	{
		switch (What & 7)
		{
		case 0:	MP->SetPRG_ROM8(0xC,4);	break;
		case 1:	MP->SetPRG_ROM8(0xC,3);	break;
		case 2:	MP->SetPRG_ROM8(0xC,4);	break;
		case 3:	MP->SetPRG_ROM8(0xC,4);	break;
		case 4:	MP->SetPRG_ROM8(0xC,4);	break;
		case 5:	MP->SetPRG_ROM8(0xC,7);	break;
		case 6:	MP->SetPRG_ROM8(0xC,5);	break;
		case 7:	MP->SetPRG_ROM8(0xC,6);	break;
		}
	}
	if ((Loc & 0x1FF) == 0x122)
	{
		if (What & 3)
			Mapper.IRQenabled = 1;
		else
		{
			Mapper.IRQcounter = 0;
			Mapper.IRQenabled = 0;
		}
	}
}

static	void	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	u8 x;

	MP = _MP;

	Mapper.PRG_Write_4 = MP->GetWriteHandler(0x4);

	MP->SetReadHandler(0x5,MP->GetReadHandler(0x8));

	for (x = 0x4; x <= 0xF; x++)
		MP->SetWriteHandler(x,PRG_Write_456789ABCDEF);

	MP->SetPRG_ROM4(0x5,(8 << 1) | 1);
	MP->SetPRG_ROM8(0x6,2);
	MP->SetPRG_ROM8(0x8,1);
	MP->SetPRG_ROM8(0xA,0);
	MP->SetPRG_ROM8(0xC,4);
	MP->SetPRG_ROM8(0xE,9);

	MP->SetCHR_RAM8(0,0);

	iNES_InitROM();

	Mapper.IRQenabled = 1;
	Mapper.IRQcounter = 0;
}

const	TMapperInfo	MapperInfo_043 =
{
	"BTL_7005 (SMB2j)",
	43,
	MS_Full,
	4096,
	InitMapper,
	UnloadMapper,
	HBlank,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};
