#include	"..\DLL\d_iNES.h"
#include	"..\Hardware\h_MMC3.h"

static	struct
{
	u8 Reg;
}	Mapper;

static	void	Sync (void)
{
	MMC3_SyncMirror();
	if (Mapper.Reg & 1)
		MMC3_SyncPRG(0xF,(Mapper.Reg & 0xC0) >> 2);
	else	MP->SetPRG_ROM32(0x8,(Mapper.Reg & 0x30) >> 4);
	MMC3_SyncCHR_ROM(0x7F,(Mapper.Reg & 0xC0) << 1);
}

static	void	SaveMI (Ar128 MI)
{
	u8 x = 0;
	x += MMC3_SaveMI(MI);
	MI[x++] = Mapper.Reg;
}

static	void	LoadMI (const Ar128 MI)
{
	u8 x = 0;
	x		+= MMC3_LoadMI(MI);
	Mapper.Reg	= MI[x++];
	Sync();
}

static	void	PRG_Write_67 (int Bank, int Where, int What)
{
	Mapper.Reg = What;
	Sync();
}

static	void	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;

	MP->SetWriteHandler(0x6,PRG_Write_67);
	MP->SetWriteHandler(0x7,PRG_Write_67);

	iNES_InitROM();
	Mapper.Reg = 0;
	MMC3_Init(Sync);
}

const	TMapperInfo	MapperInfo_049 =
{
	"1993 Super HiK 4-in-1 (MMC3)",
	49,
	MS_Full,
	8192,
	InitMapper,
	UnloadMapper,
	MMC3_HBlank,
	NULL,
	SaveMI,
	LoadMI,
	NULL,
	NULL
};