#include	"..\DLL\d_iNES.h"

static	struct
{
	u8 Cmd;
}	Mapper;

static	void	SaveMI (Ar128 MI)
{
	u8 x = 0;
	MI[x++] = Mapper.Cmd;
}

static	void	LoadMI (const Ar128 MI)
{
	u8 x = 0;
	Mapper.Cmd = MI[x++];
}

static	void	PRG_Write_8 (int Bank, int Where, int What)
{
	switch (Where & 1)
	{
	case 0:	Mapper.Cmd = What & 0x07;	break;
	case 1:	if (What & 1)
			MP->Mirror_H();
		else	MP->Mirror_V();		break;
	}
}

static	void	PRG_Write_A (int Bank, int Where, int What)
{
	switch (Where & 1)
	{
	case 0:	switch (Mapper.Cmd)
		{
		case 0:	MP->SetPRG_ROM8(0x8,What);	break;
		case 1:	MP->SetPRG_ROM8(0xA,What);	break;
		case 2:	MP->SetCHR_ROM2(0,What << 1);	break;
		case 3:	MP->SetCHR_ROM2(2,What << 1);	break;
		case 4:	MP->SetCHR_ROM1(4,What);	break;
		case 5:	MP->SetCHR_ROM1(5,What);	break;
		case 6:	MP->SetCHR_ROM1(6,What);	break;
		case 7:	MP->SetCHR_ROM1(7,What);	break;
		}				break;
	case 1:	break;
	}
}

static	void	PRG_Write_E (int Bank, int Where, int What)
{
	if (What & 1)
		MP->Mirror_H();
	else	MP->Mirror_V();
}

static	void	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	MP = _MP;

	MP->SetWriteHandler(0x8,PRG_Write_8);
	MP->SetWriteHandler(0xA,PRG_Write_A);
	MP->SetWriteHandler(0xE,PRG_Write_E);

	MP->SetPRG_ROM16(0x8,0);
	MP->SetPRG_ROM16(0xC,-1);
	MP->SetCHR_ROM8(0,0);

	iNES_InitROM();
}

const	TMapperInfo	MapperInfo_112 =
{
	"Mapper 112",
	112,
	MS_Partial,
	8192,
	InitMapper,
	UnloadMapper,
	NULL,
	NULL,
	SaveMI,
	LoadMI,
	NULL,
	NULL
};